using System;
using Unit4.UtilsLib;
using Unit4.CollectionsLib;

/// <summary>
///   1    -  --   
/// </summary>
/// <author>   ,   ,  ,  </author>
/// <version> 28.11.2007 </version>

public class BuildBalancedTreeFromSortedList
{
	public static void Main(string[] args)
	{
        Random rnd = new Random();
		int n = rnd.Next(20)+1;
		List<int> lst = ListUtils.InsertionSort(ListUtils.CreateRandomList(n, 0, 100));
		Console.WriteLine(lst);

        //  :  - / 
        //    ,  ,  0
        //       -   
        BinTreeNode<int> balancedTree = BuildBT(n);
        Console.WriteLine(BinTreeUtils.InOrderTraversal(balancedTree));

		//  :         
        //            --  
        InsertNumsIntoBT(balancedTree, lst);
        Console.WriteLine(BinTreeUtils.InOrderTraversal(balancedTree));
	}

    // numNodes             
    public static BinTreeNode<int> BuildBT(int numNodes)
    {
        BinTreeNode<int> balancedTree = new BinTreeNode<int>(0);
        Queue<BinTreeNode<int>> q = new Queue<BinTreeNode<int>>();
       
        q.Insert(balancedTree);
        for (int i = 2; i <= numNodes; i++)
        {
            if (q.Head().GetLeft() == null)
                q.Head().SetLeft(new BinTreeNode<int>(0));
            else
                if (q.Head().GetRight() == null)
                {
                    q.Head().SetRight(new BinTreeNode<int>(0));
                    q.Insert(q.Head().GetLeft());
                    q.Insert(q.Head().GetRight());
                    q.Remove();
                }
        }

        return balancedTree;
    }

    //          --
	public static void InsertNumsIntoBT(BinTreeNode<int> bt, List<int> lst)
	{
		if(bt != null)
		{
            InsertNumsIntoBT(bt.GetLeft(), lst);
			bt.SetInfo(lst.GetFirst().GetInfo());
			lst.Remove(lst.GetFirst());
            InsertNumsIntoBT(bt.GetRight(), lst);
		}
	}
}
