using Unit4.CollectionsLib;

/// <summary>
///   2    -       
/// </summary>
/// <author>   ,   ,  ,  </author>
/// <version> 28.11.2007 </version>

public class Page 
{
	private string name;
	private List<Page> links;
	private int numOfLinks;

    public Page(string name)
	{
		this.name = name;
		this.links = new List<Page>();
		this.numOfLinks = 0;
	}

    public string GetName()
	{
		return this.name;
	}
	
	public void AddLink(Page link)
	{
		this.links.Insert(null, link);
		this.numOfLinks++;
	}
	
	
	public Page[] GetAllLinks()
	{
		Page[] allLinks = new Page[this.numOfLinks];
		Node<Page> pos = this.links.GetFirst();
		int i=0;
		
		while(pos!=null)
		{
			allLinks[i] = pos.GetInfo();
			i++;
			pos = pos.GetNext();
		}
		
		return allLinks;
	}

	// ":  " 
	public bool CanGoTo(Page page)
	{
	  Queue<Page> q = new Queue<Page>();
	  
      q.Insert(this);
      while (!q.IsEmpty()) 
      {   
    	  Page p = q.Remove();
    	  Page[] pages = p.GetAllLinks();
          for (int i = 0; i < pages.Length; i++)
          {
        	  if(page == pages[i])
        		  return true;
              	q.Insert(pages[i]);
          }
      }
      return false;
	}

    public override string ToString()
	{
		if(this.numOfLinks==0)
            return ("No links on this page!");

        string str = "Page " + this.name + " has " + this.numOfLinks + " links as follow:\n";
		Node<Page> pos = this.links.GetFirst();
		
		while(pos!=null)
		{
			str = str + pos.GetInfo().GetName() + "\n";
			pos = pos.GetNext();
		}
		
		return(str);
	}
}
